Exec { timeout => 300 }

$neutron_db_host = '10.35.117.10'
$neutron_db_name = 'ovs_neutron'
$neutron_db_user = 'neutron'
$neutron_db_password = '7da2e20dfe464de6'
$neutron_sql_connection = "mysql://${neutron_db_user}:${neutron_db_password}@${neutron_db_host}/${neutron_db_name}"

$neutron_user_password = '7b279d5b7683497c'



class { 'neutron':
  rabbit_host           => '10.35.117.10',
  rabbit_port           => '5672',
  rabbit_user           => 'guest',
  rabbit_password       => 'guest',
  core_plugin           => 'neutron.plugins.openvswitch.ovs_neutron_plugin.OVSNeutronPluginV2',
  allow_overlapping_ips => true,
  service_plugins       => ['neutron.services.loadbalancer.plugin.LoadBalancerPlugin', 'neutron.services.firewall.fwaas_plugin.FirewallPlugin'],
  verbose               => true,
  debug                 => true,
}

# Create firewall rules to allow only the FIREWALL_ALLOWED
# hosts that need to connect via FIREWALL_PORTS
# using FIREWALL_CHAIN

packstack::firewall {'neutron_tunnel':
  host => 'ALL',
  service_name => 'neutron tunnel port',
  chain => 'INPUT',
  ports => undef,
  proto => 'gre',
}

class { 'neutron::agents::l3':
  interface_driver        => 'neutron.agent.linux.interface.OVSInterfaceDriver',
  external_network_bridge => '',
  debug                   => true,
}

sysctl::value { 'net.ipv4.ip_forward':
  value => '1'
}


if "" {
  $iface = regsubst('', '[\.\-\:]', '_', 'G')
  $localip = inline_template("<%= scope.lookupvar('::ipaddress_${iface}') %>")
} else {
  $localip = '10.35.117.12'
}

if 'openvswitch' == 'ml2' {
  class { 'neutron::agents::ml2::ovs':
    bridge_mappings  => ['ext_vlan:br-ex'],
    enable_tunneling => true,
    tunnel_types     => ['gre'],
    local_ip         => $localip,
    l2_population    => false,
  }
} else {
  class { 'neutron::agents::ovs':
    bridge_mappings  => ['ext_vlan:br-ex'],
    enable_tunneling => true,
    tunnel_types     => ['gre'],
    local_ip         => $localip,
  }

  file { 'ovs_neutron_plugin.ini':
    path    => '/etc/neutron/plugins/openvswitch/ovs_neutron_plugin.ini',
    owner   => 'root',
    group   => 'neutron',
    before  => Service['ovs-cleanup-service'],
    require => Package['neutron-plugin-ovs'],
  }
}


vs_port { 'eth3':
  bridge => 'br-ex',
  ensure => present
}



class { 'neutron::agents::dhcp':
  interface_driver => 'neutron.agent.linux.interface.OVSInterfaceDriver',
  debug            => true,
}
# Create firewall rules to allow only the FIREWALL_ALLOWED
# hosts that need to connect via FIREWALL_PORTS
# using FIREWALL_CHAIN

packstack::firewall {'neutron_dhcp_in_10.35.117.12':
  host => 'ALL',
  service_name => 'neutron dhcp in: ',
  chain => 'INPUT',
  ports => '67',
  proto => 'udp',
}
# Create firewall rules to allow only the FIREWALL_ALLOWED
# hosts that need to connect via FIREWALL_PORTS
# using FIREWALL_CHAIN

packstack::firewall {'neutron_dhcp_out_10.35.117.12':
  host => 'ALL',
  service_name => 'neutron dhcp out: ',
  chain => 'OUTPUT',
  ports => '68',
  proto => 'udp',
}

class { 'neutron::agents::lbaas':
  interface_driver => 'neutron.agent.linux.interface.OVSInterfaceDriver',
  device_driver    => 'neutron.services.loadbalancer.drivers.haproxy.namespace_driver.HaproxyNSDriver',
  user_group       => 'haproxy',
  debug            => true,
}


class {'neutron::agents::metadata':
  auth_password => '7b279d5b7683497c',
  auth_url      => 'http://10.35.117.10:35357/v2.0',
  shared_secret => 'aebf1075b15448f1',
  metadata_ip   => '10.35.117.10',
  debug         => true,
}

